#include "encabezados.h"

extern pid_t pid_l, pid_r;
extern int pfd[2];
extern int pfd_[2];
extern FILE * sd_local;
extern FILE * sd_remoto;

void crear_hijos() {
  /*
   * Create a pipe.
   */
  if (pipe(pfd) < 0) {
    perror("pipe");
    exit(1);
  }
  /*
   * Create a child process.
   */
  if ((pid_l = fork()) < 0) {
    perror("fork");
    exit(1);
  }
  /*
   * The child process executes "gnuplot".
   */
  if (pid_l == 0) {
    /*
     * Attach standard input of this child process to read from the pipe.
     */
    dup2(pfd[0], 0);
    close(pfd[1]);  /* close the write end off the pipe */
    execlp("gnuplot", "gnuplot", 0);
    perror("exec");
    _exit(127);
  }
  
  /*
   * We won't be reading from the pipe.
   */
  close(pfd[0]);
  sd_local = fdopen(pfd[1], "w");
  
  
  /*
   * Create another pipe.
   */
  if (pipe(pfd_) < 0) {
    perror("pipe");
    exit(1);
  }
  /*
   * Create a child process.
   */
  if ((pid_r = fork()) < 0) {
    perror("fork");
    exit(1);
  }
  /*
   * The child process executes "gnuplot".
   */
  if (pid_r == 0) {
    /*
     * Attach standard input of this child process to read from the pipe.
     */
    dup2(pfd_[0], 0);
    close(pfd_[1]);  /* close the write end off the pipe */
    execlp("gnuplot", "gnuplot", 0);
    perror("exec");
    _exit(127);
  }

  /*
   * We won't be reading from the pipe.
   */
  close(pfd_[0]);
  sd_remoto = fdopen(pfd_[1], "w");

  return;
}
