/*
*******************************
*TAREA 3
*PROGRAMACION DE SISTEMAS
*PROF: AGUSTIN GONZALEZ
*AUTOR: EDUARDO GONZALEZ FISHER
*ROL:   2021010-9
*******************************
*/

#include "encabezados.h"
#define ESPERAR 0
#define HORIZONTAL 1
#define VERTICAL 0


int matriz[10][10];
FILE *tmp;
int posy, posx;
int aciertos_mios;
int aciertos_enemigo;



/* variables para hijos */
pid_t pid_l, pid_r;
int pfd[2];
int pfd_[2];
FILE * sd_local;
FILE * sd_remoto;

/* variables para servidor y cliente */
int socket_servidor;
int socket_cliente;
int puerto_remoto;
int puerto_local;
struct sockaddr_in name_s;
struct sockaddr_in name_c;
int conexion;
char destino[64];
struct hostent *hp;
  


/* otras */
int check_matrix(int,int,int,int);
void terminar();
void ocupar(int,int,int,int);
int orientacion(int, int *, int *);
void bugg();  // hace un printf , solo para detectar errores en el codigo  =)

/* funciones */
extern void crear_hijos();
extern int servidor();
extern int cliente();
extern int disparar();


int main(int argc, char *argv[])
{
  int i,j, status;
  int valido = 1;
  int inicio;
  int horizontal;
  int limitex, limitey;


  /*Verificar el ingreso de parametros*/
  if ( argc == 7) {
    if ( fopen(argv[1],"r")  == NULL ) {
      printf("Archivo de texto (\"%s\") inexistente\nUso: %s [archivo del portavion] [archivo de la fragata] [archivo del submarino]\n",argv[1],argv[0]);
      exit(-1);
    }
    if ( fopen(argv[2],"r") == NULL ) {
      printf("Archivo de texto (\"%s\") inexistente\nUso: %s [archivo del portavion] [archivo de la fragata] [archivo del submarino]\n",argv[2],argv[0]);
      exit(-1);
    }
    if ( fopen(argv[3],"r") == NULL ) {
      printf("Archivo de texto (\"%s\") inexistente\nUso: %s [archivo del portavion] [archivo de la fragata] [archivo del submarino]\n",argv[3],argv[0]);
      exit(-1);
    }
    puerto_local = atoi(argv[4]);
    puerto_remoto = atoi(argv[6]);
  }
  else {
    printf("\nError en la linea de comando!.\n> ");
    printf("Uso: %s [archivo del portavion] [archivo de la fragata] [archivo del submarino] [puerto local] [destino] [puerto remoto]\n",argv[0]);
    exit(-1);
  }

  /* llenar la matriz */
  for(i=0;i<10;i++)
    for(j=0;j<10;j++)
      matriz[i][j] = 0;

  /* crear los hijos y los "pipes" a cada uno */
  crear_hijos();


  /*
   * Muestra la grilla local
   */
  
  fprintf(sd_local, "set xrange [0:999]\n");
  fprintf(sd_local, "set yrange [0:999]\n");
  fprintf(sd_local, "set xtics border nomirror (\"0\" 50,\"1\" 150,\"2\" 250,\"3\" 350,\"4\" 450,\"5\" 550,\"6\" 650,\"7\" 750,\"8\" 850,\"9\" 950)\n");
  fprintf(sd_local, "set ytics border nomirror rotate (\"0\" 50,\"1\" 150,\"2\" 250,\"3\" 350,\"4\" 450,\"5\" 550,\"6\" 650,\"7\" 750,\"8\" 850,\"9\" 950)\n");
  fprintf(sd_local, "set x2tics 50, 100\n");
  fprintf(sd_local, "set y2tics 50, 100\n");
  fprintf(sd_local, "set mx2tics 2\n");
  fprintf(sd_local, "set my2tics 2\n");
  fprintf(sd_local, "set format x2 \"\"; set format y2 \"\"\n"); // elimina la etiqueta de ejes x2 y2
  fprintf(sd_local, "set grid my2tics mx2tics linetype 0\n");
  fprintf(sd_local, "set multiplot\n");
  fprintf(sd_local, "set nokey\n");
  fprintf(sd_local, "set title \"Batalla Naval v2.0 -- Pantalla Local\" \n");
  fprintf(sd_local, "plot -2\n"); //muestra el campo de batalla
  fprintf(sd_local, "set parametric\npause -1\n");
  fflush(sd_local);
  
  /*
   * Muestra la grilla remota
   */
  
  fprintf(sd_remoto, "set xrange [0:999]\n");
  fprintf(sd_remoto, "set yrange [0:999]\n");
  fprintf(sd_remoto, "set xtics border nomirror (\"0\" 50,\"1\" 150,\"2\" 250,\"3\" 350,\"4\" 450,\"5\" 550,\"6\" 650,\"7\" 750,\"8\" 850,\"9\" 950)\n");
  fprintf(sd_remoto, "set ytics border nomirror rotate (\"0\" 50,\"1\" 150,\"2\" 250,\"3\" 350,\"4\" 450,\"5\" 550,\"6\" 650,\"7\" 750,\"8\" 850,\"9\" 950)\n");
  fprintf(sd_remoto, "set x2tics 50, 100\n");
  fprintf(sd_remoto, "set y2tics 50, 100\n");
  fprintf(sd_remoto, "set mx2tics 2\n");
  fprintf(sd_remoto, "set my2tics 2\n");
  fprintf(sd_remoto, "set format x2 \"\"; set format y2 \"\"\n"); // elimina la etiqueta de ejes x2 y2
  fprintf(sd_remoto, "set grid my2tics mx2tics linetype 0\n");
  fprintf(sd_remoto, "set multiplot\n");
  fprintf(sd_remoto, "set nokey\n");
  fprintf(sd_remoto, "set title \"Batalla Naval v2.0 -- Pantalla del Oponente\" \n");
  fprintf(sd_remoto, "plot -2\n"); //muestra el campo de batalla
  fprintf(sd_remoto, "set parametric\npause -1\n");
  fflush(sd_remoto);
  

  /**********************PORTA AVIONES***************/
  printf("\n");
  horizontal = orientacion(0,&limitex,&limitey);
  do{
    if (valido==0)
      printf("Posicion no valida... dibujo queda fuera del area o sobre otro navio.\n");
    printf("\nIngrese la posicion en donde ubicar el portaaviones (x y): ");
    valido = 0;
    posy=2; posx=3;
    scanf("%d%d",&posx,&posy);
  } while(posx<0 || posx>limitex || posy<0 || posy>limitey || check_matrix(posx,posy,0,horizontal) );
  ocupar(posx,posy,0,horizontal);  
  /*
    matriz[posx][posy] = 1;
    matriz[posx+1][posy] = 1;
    matriz[posx+2][posy] = 1;
  */  
  valido = 1;
  if (horizontal)
    fprintf(sd_local, "\nplot \"%s\" using ($1+%i):($2+%i) with lines  1\n", argv[1], posx*100, posy*100);
  else
    fprintf(sd_local, "\nplot \"%s\" using ($2+%i):($1+%i) with lines  1\n", argv[1], posx*100, posy*100);
  fprintf(sd_local, "\n");
  fflush(sd_local);
  
  /********** FRAGATA  ***************/
  horizontal = orientacion(1,&limitex,&limitey);
  do{
    if (valido==0)
      printf("Posicion no valida... dibujo queda fuera del area o sobre otro navio.\n");
    printf("\nIngrese la posicion en donde ubicar la fragata (x y): ");
    valido = 0;
    posx=7;posy=7;
    scanf("%d%d",&posx,&posy);
  } while(posx<0 || posx>limitex || posy<0 || posy>limitey || check_matrix(posx,posy,1,horizontal));
  ocupar(posx,posy,1,horizontal);  
  /*
    matriz[posx][posy] = 2;
    matriz[posx+1][posy] = 2;
  */
  valido = 1;
  if (horizontal)
    fprintf(sd_local, "\nplot \"%s\" using ($1+%i):($2+%i) with lines 4\n", argv[2], posx*100, posy*100);
  else
    fprintf(sd_local, "\nplot \"%s\" using ($2+%i):($1+%i) with lines 4\n", argv[2], posx*100, posy*100);
  fprintf(sd_local, "\n");
  fflush(sd_local);
  
  /********** SUBMARINO  ***************/
  //horizontal = orientacion(2,&limitex,&limitey);
  do{
    if (valido==0)
      printf("Posicion no valida... dibujo queda fuera del area o sobre otro navio.\n");
    printf("\nIngrese la posicion en donde ubicar el submarino (x y): ");
    valido = 0;
    posx=5;posy=1;
    scanf("%d%d",&posx,&posy);
  } while(posx<0 || posx>9 || posy<0 || posy>9 || check_matrix(posx,posy,2,horizontal));
  ocupar(posx,posy,2,horizontal);  
  valido = 1;
  fprintf(sd_local, "\nplot \"%s\" using ($1+%i):($2+%i) with lines 6\n", argv[3], posx*100, posy*100);
  fprintf(sd_local, "\n"); 
  fflush(sd_local);
  
  /* HASTA ACA TODO BIEN */
  aciertos_mios = 0;
  aciertos_enemigo = 0;

  /*
    Intentar Conectarse al oponente
  */
  strcpy(destino, argv[5]);
  inicio = cliente();

  /*
    Crear el servidor
  */
  servidor();

  sleep(2);

  /*
    Intentar Conectarse al oponente si no se ha realizado la conexion
  */
  if (inicio!=ESPERAR) connect(socket_cliente, (struct sockaddr *) &name_c, sizeof(struct sockaddr_in));

  printf("-*- La conexion se ha establecido -*-\n");
  fflush(stdout);
  valido=1;
  /* A PARTIR DE ESTE PUNTO LA CONEXION ESTA HECHA */

  if (inicio!=ESPERAR) {
    disparar();
    rec_respuesta();
  }
  do {
    esperar_turno();
    if (aciertos_enemigo == 6) terminar(0);
    disparar();
    rec_respuesta();
    if (aciertos_mios == 6) terminar(1);
  } while (1);
  
  exit(0);
}

int check_matrix(int x, int y, int tipo, int orien){
  switch (tipo) {
  case 0:
    if (orien==HORIZONTAL)
      return (matriz[x][y] || matriz[x+1][y] || matriz[x+2][y]);
    else
      return (matriz[x][y] || matriz[x][y+1] || matriz[x][y+2]);			 
  case 1:
    if (orien==HORIZONTAL)
      return (matriz[x][y] || matriz[x+1][y]);
    else
      return (matriz[x][y] || matriz[x][y+1]);
  default:
    return matriz[x][y];
  }
}

void ocupar(int x, int y, int tipo, int orien) {
  switch (tipo) {
  case 0:
    if (orien==HORIZONTAL) {
      matriz[x][y] = tipo + 1;
      matriz[x+1][y] = tipo + 1;
      matriz[x+2][y] = tipo + 1;
    }
    else {
      matriz[x][y] = tipo + 1;
      matriz[x][y+1] = tipo + 1;
      matriz[x][y+2] = tipo + 1;
    }
    break;
  case 1: 
    if (orien==HORIZONTAL) {
      matriz[x][y] = tipo + 1;
      matriz[x+1][y] = tipo + 1;
    }
    else {
      matriz[x][y] = tipo + 1;
      matriz[x][y+1] = tipo + 1;
    }
    break;
  default:
    matriz[x][y] = tipo + 1;
    break;
  }
  return;
}

void terminar(int Z){
  int status;
  if (Z==1) printf("\nFIN del juego.... Eres el GANADOR.\n");
  else printf("\nFIN del juego.... Perdiste.\n");
  fflush(stdout);
  fflush(stdin);
  getchar();
  getchar();
  fprintf(sd_local, "\n exit\n");
  fprintf(sd_remoto, "\n exit\n");
  close(conexion);
  close(socket_servidor);
  close(socket_cliente);
  fcloseall();
  waitpid(pid_r, &status, 0);
  waitpid(pid_l, &status, 0);
  exit(0);
}

int orientacion(int barco, int *x, int *y) {
  int orien=2;
  *x = 9;
  *y = 9; 
  while (orien<0 || orien>1 )  {
    switch (barco) {
    case 0:
      printf("Como quiere poner el Porta-Aviones?\n (1)Horizontal  (0)Vertical\n");fflush(stdout);
      break;
    case 1:
      printf("Como quiere poner el Crucero?\n (1)Horizontal  (0)Vertical\n");fflush(stdout);
      break;
    default:
      printf("Como quiere poner el Submarino?\n (1)Horizontal  (0)Vertical\n");fflush(stdout);
      break;
    }
    scanf("%d",&orien); 
  }
  
  switch (barco) {
  case 0:
    if (orien)
      *x = 7;
    else
      *y = 7; 
    break;
  case 1:
    if (orien)
      *x = 8;
    else
      *y = 8;
    break;
  default:
    break;
  }
    return orien;
}

void bugg(void){
  printf("|*_^_*| ");
  fflush(stdout);
  return;
}
